
from cStringIO import StringIO

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.BlobFile.config import PROJECT_NAME, TOOL_NAME
from Products.CMFCore.utils import getToolByName

def installTool(self, out):
    tool = getToolByName(self, TOOL_NAME, None)
    if tool is None:
        addTool = self.manage_addProduct[PROJECT_NAME].manage_addTool
        addTool('Blob Tool')
        print >> out, 'Installed BlobFile support tool'

def installConfiglets(self, out):
    try:
        cp = getToolByName(self, 'portal_controlpanel')
    except:
        print >> out, "Plone configlets not installed since no Plone " \
                      "control panel tool is available"
        return

    configlets = cp.enumConfiglets(group='Products')
    installed = False
    for configlet in configlets:
        if configlet['id'] == 'blobfile-config':
            installed = True
        
    if not installed:
        cp.registerConfiglet(
            'blobfile-config', #id of your Tool
            'BlobFile Configuration', # Title of your Product
            'string:${portal_url}/blobfile-config.html',
            'python:True', # a condition
            'Manage Portal', # access permission
            'Products', # section to which the configlet should be added: (Plone,Products,Members)
            1, # visibility
            '',
            'site_icon.gif', # icon in control_panel
            'Configuration for BlobFile.',
            None,
        )
        
        print >> out, "Configlets installed"
    else:
        print >> out, "Configlet installation not required"

def install(self):
    out = StringIO()
    installTypes(self, out, listTypes(PROJECT_NAME), PROJECT_NAME)
    installTool(self, out)
    installConfiglets(self, out)
        
    print >> out, 'Successfully installed %s.' % PROJECT_NAME

    return out.getvalue()
