import os
from Products.CMFCore import utils as cmfutils

class ConfigForm(object):
    """A form for configuring the BlobFile product.
    """

    def __init__(self, context, request):
        self.context = context
        self.request = request
        self.blobtool = cmfutils.getToolByName(context, 'portal_blob')

    def __call__(self):
        if self.request.form.get('form_submit', False):
            self.blob_dir = self.request.form['blob_dir']
            self.request.set('portal_status_message', 'Configuration saved.')
            return self.index()
        elif self.request.form.get('form.button.cancel', False):
            self.request.RESPONSE.redirect('plone_memberprefs_panel')
        else:
            return self.index()

    def blob_dir(self, blob_dir=None):
        if blob_dir is not None:
            self.ensure_exists(blob_dir)
            self.blobtool.manage_configure(blob_dir=blob_dir)
        return self.blobtool.getBlobDir()
    blob_dir = property(blob_dir, blob_dir)

    def ensure_exists(self, dir):
        if not os.path.exists(dir):
            os.makedirs(dir)
