
import os
import shutil
from Testing import ZopeTestCase
from Testing.ZopeTestCase import doctest, Functional
from Products.PloneTestCase import PloneTestCase
from Products.BlobFile.config import TOOL_NAME
from Products.CMFCore.utils import getToolByName

PloneTestCase.installProduct('blob')
PloneTestCase.installProduct('BlobFile')
try:
    import Products.DavPack
    PloneTestCase.installProduct('DavPack')
except ImportError, e:
    pass
PloneTestCase.setupPloneSite(products=('BlobFile',))

test_home = os.path.dirname(__file__)
data_dir = os.path.join(test_home, 'data')
blob_dir = os.path.join(test_home, 'filedata')

from zExceptions.ExceptionFormatter import format_exception
from ZPublisher.HTTPResponse import HTTPResponse

# Silence Plone's handling of exceptions
orig_exception = HTTPResponse.exception
def exception(self, **kw):
    def tag_search(*args):
        return False
    kw['tag_search'] = tag_search
    return orig_exception(self, **kw)

orig_setBody = HTTPResponse.setBody
def setBody(self, *args, **kw):
    kw['is_error'] = 0
    if isinstance(args[0], tuple) and len(args[0]) == 2:
        title, body = args[0]
        args = (body,) + args[1:]
    return orig_setBody(self, *args, **kw)

def _traceback(self, t, v, tb, as_html=1):
    return ''.join(format_exception(t, v, tb, as_html=as_html))

HTTPResponse._error_format = 'text/plain'
HTTPResponse._traceback = _traceback
HTTPResponse.exception = exception
HTTPResponse.setBody = setBody

class TestCase(PloneTestCase.PloneTestCase):
    
    def afterSetUp(self):
        tool = getToolByName(self.portal, TOOL_NAME)
        
        tool.manage_configure(blob_dir=blob_dir)

class FunctionalTestCase(Functional, TestCase):

    #def beforeTearDown(self):
    #    self.portal.manage_delObjects(ids=['test_file'])
    
    __implements__ = (Functional.__implements__,
                      TestCase.__implements__)

