
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing.ZopeTestCase import user_name, user_password

from base import TestCase, blob_dir
from Products.CMFCore.utils import getToolByName
from Products.BlobFile.config import TOOL_NAME

class TestBlobFile(TestCase):

    def testTool(self):
        self.setRoles(['Manager'])
        self.login(user_name)
        tool = getToolByName(self.portal, TOOL_NAME)
        self.assertEquals(tool.getBlobDir(), blob_dir)
        test_path = '/tmp/filedata'
        self.assertRaises(ValueError, tool.manage_configure, 
                          blob_dir=test_path)

    def testAddFile(self):
        self.setRoles(['Member'])
        self.login(user_name)
        home_folder = getattr(self.portal.Members, user_name)
        home_folder.invokeFactory('BlobFile', 'test_file')
        self.failUnless('test_file' in home_folder.contentIds())
        bfile = home_folder.test_file
        bfile.setFile('This is a test')
        self.assertEquals(bfile.getFile().getIterator().next(), 
            'This is a test')
        


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestBlobFile))
    return suite

if __name__ == '__main__':
    framework()

